#!/usr/local/bin/perl

package IPAnalyze::Customers;

sub new {
	my $me = shift;
	return bless({}, $me);
}

sub name {
	my $me = shift;
	my $dbh = shift;
	my $acct = shift || die "name syntax error1: $acct";
	
	my $sql = 'SELECT company_name FROM customers WHERE account_number = ' . $dbh->quote($acct);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row = $sth->fetchrow_arrayref;
	return($row->[0]);
}
	
sub count {
	my $me = shift;
	my $dbh = shift;
	my $acct = shift || die "count syntax error2";

	my $sql = 'SELECT COUNT(*) FROM customers WHERE account_number = ' . $dbh->quote($acct);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row = $sth->fetchrow_arrayref;
	return($row->[0]);
}

sub insert {
	my $me = shift;
	my $dbh = shift;
	my $data = shift || die "insert syntax error";

	my (@keys,@values);
	while(my($key,$value) = each %{$data}){
		push @keys, $key;
		push @values, $value;
	}
	my $sql = 'INSERT INTO customers (';
	foreach my $key (@keys){
		$sql .= "$key,";
	}
	chop($sql);
	$sql .= ') VALUES (';
	foreach my $value (@values){
		$sql .= $dbh->quote($value) . ',';
	}
	chop($sql);
	$sql .= ')';
	
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	return;
}

sub update {
	my $me = shift;
	my $dbh = shift;
	my $acct = shift || die "update syntax erro1";
	my $data = shift || die "update syntax error2"; # hashref

	my $sql = 'UPDATE customers SET ';
	while(my($key,$value) = each %{$data}){
		$sql .= "$key = " . $dbh->quote($value) . ',';
	}
	chop($sql);
	$sql .= ' WHERE account_number = ' . $dbh->quote($acct);
	my $sth = $dbh->prepare($sql);
	$sth->execute;

	return;
}

sub all {
	my $me = shift;
	my $dbh = shift;
	my $acct = shift || die "all syntax error2";

	# the order in $stuff is important.  
	my $stuff = 'company_name,address,city,state,zip,country';
	my $sql = "SELECT $stuff FROM customers WHERE account_number = " . $dbh->quote($acct);
	my $sth = $dbh->prepare($sql);
	$sth->execute;
	my $row = $sth->fetchrow_arrayref;
	return($row);
}

return 1;
