#!/usr/local/bin/perl

use lib ('/export/web/ipanalyze.example.com/data/lib');

use strict;
use DBI;
use IPAnalyze::Misc;
use IPAnalyze::IPmath;

my $area = 1; # null for everything
my $DEBUG=1;
my %cfg;
open(CONFIG, '/export/web/ipanalyze.example.com/data/ipanalyze.conf') || die "cannot open config: $!\n";
while(<CONFIG>){
   next if(/^[#;]/);
   chomp;
   if(/^(\S+)\s*=>\s?(.+)/){
      $cfg{$1} = $2;
   }
}
close CONFIG;

my $dbh = DBI->connect($cfg{d_dsn}, $cfg{d_dbun}, $cfg{d_dbpw}, {RaiseError => 1});

my $misc = IPAnalyze::Misc->new();
my $ipmath = IPAnalyze::IPmath->new();

my %e = ( 30 => 'A', 29 => 'B', 28 => 'C', 27 => 'D',
          26 => 'E', 25 => 'F', 24 => 'G', 23 => 'H',
          22 => 'I', 21 => 'J', 20 => 'K' );

my $rows = 120;

my $sql = 'SELECT netblock,cidr FROM data WHERE netblock IS NOT NULL AND area = 1';
if($area){
	$sql .= ' AND area = 1';
}
my $sth = $dbh->prepare($sql);
$sth->execute;
my %used;
while(my $row = $sth->fetchrow_arrayref){
	$used{$row->[0]} = $row->[1];
}

# now we have a built hash of what is in use
# get info on what is total

if($ARGV[0] eq '-f'){
	$sql = 'SELECT netblock,cidr FROM grandparent_networks';
}else{
	$sql = 'SELECT netblock,cidr FROM parent_networks WHERE allow_use = 1';
	if($area){
		$sql .= ' AND area = 1';
	}
}
my $sth = $dbh->prepare($sql);
$sth->execute;
my %total;
while(my $row = $sth->fetchrow_arrayref){
	$total{$row->[0]} = $row->[1];
}
print "\n";

my $r=0;
for(map { $_->[0] }
    sort { $a->[0] <=> $b->[0] ||
           $a->[1] <=> $b->[1] ||
           $a->[2] <=> $b->[2] ||
           $a->[3] <=> $b->[3] }
    map { [ $_, split /\./ ] } keys %total){

	print "\nFOR $_ $total{$_}\n";

	my @netblocks = $ipmath->get_netblocks($_,$total{$_},30);
	my ($skip,$l);
	foreach my $block (@netblocks){
		$r++;
		if($skip){
			print "$l";
			$skip--;
		}else{
			if(my $cidr = $used{$block}){
				print $e{$cidr};
				$l = $e{$cidr};
				if($cidr != 30){
					$skip = ((2 ** (30-$cidr)) - 1); # how many other 30s are in $cidr
				}
			}else{
				print "U";
			}
		}
		if($r == $rows){
			$r = 0;
			#print "\n";
		}
	}
}

print "\n";
